
%apply (int DIM1, double* IN_ARRAY1) {(int xd, double* px), (int md, double* mu)};
%apply (int DIM1, int DIM2, double* IN_ARRAY2) {(int sd, int sp, double* sigma)};
double mvnpdf(int xd, double* px, int md, double* mu, int sd, int sp, double* sigma);

double wmvnpdf(int xd, double* px,
	 double pi,
	 int md, double* mu,
	 int sd, int sp, double* sigma);


%apply (int DIM1, int DIM2, double* IN_ARRAY2) {(int xd, int xp, double* px)};
%apply (int DIM1, double* IN_ARRAY1) {(int md, double* mu)};
%apply (int DIM1, double* ARGOUT_ARRAY1) {(int outd, double* out)};
void mvnpdf(int xd, int xp, double* px, 
	 int md, double* mu,
	 int sd, int sp, double* sigma,
	 int outd, double* out);
 
 
%exception wmvnpdf {
   try {
      $action
   } catch (invalid_argument &e) {
      PyErr_SetString(PyExc_ValueError, const_cast<char*>(e.what()));
      return NULL;
   }
}
 
void wmvnpdf(int xd, int xp, double* px, 
	 double pi,
	 int md, double* mu,
	 int sd, int sp, double* sigma,
	 int outd, double* out);


%apply (int DIM1, double* IN_ARRAY1) {(int pd, double* pi)};
%apply (int DIM1, int DIM2, double* IN_ARRAY2) {(int md, int mp, double* mu )};
%apply (int DIM1, int DIM2, int DIM3, double* IN_ARRAY3) {(int sk, int sd, int sp, double* sigma)};
%apply (int DIM1, double* ARGOUT_ARRAY1) {(int outd, double* out)};
void wmvnpdf(int xd, int xp, double* px, 
	int pd, double* pi,
	int md, int mp, double* mu,
	int sk, int sd, int sp, double* sigma,
	int outd, double* out);
